<script setup>
import { onBeforeMount } from 'vue';
import { CdxTextInput, CdxButton, CdxIcon, CdxMultiselectLookup, CdxSelect, CdxField } from '@wikimedia/codex';
import { cdxIconTrash, cdxIconAdd } from '@wikimedia/codex-icons';
import { useInstrumentStore } from '../../stores/instrument.js'
import { useLocationStore } from '../../stores/location.js';
import { ref } from 'vue'

const instrumentStore = useInstrumentStore();
const locationStore = useLocationStore();

//const locationsChips = ref( instrumentStore.instrument.sample_rate.custom )
const locationsMenuItems = ref( [] )
let locationsItems = []

onBeforeMount(async () => {
    await locationStore.refreshLocations()
    locationsItems = locationStore.locations.map( item => ({label: item, value: item}) )
})

const samplingUnitMenuItems = [
    {
        label: 'pageview',
        value: 'pageview',
        description: 'Tracks each time a web page is loaded or reloaded by the user'
    },
    {
        label: 'session',
        value: 'session',
        description: 'Captures all user activity during a single visit, including multiple pageviews'
    },
    {
        label: 'device',
        value: 'device',
        description: 'Tracks all interactions from a specific device, covering multiple sessions and pageviews'
    }
];

function onLocationsInput( value ) {
    if ( value ) {
        locationsMenuItems.value = locationsItems.filter( ( item ) =>
            item.label.toLowerCase().includes( value.toLowerCase() )
        )
    } else {
        locationsMenuItems.value = []
    }
}

function wikisChanged(rateObj, newValue) {
    if (newValue.length === 0) {
        return
    }

    rateObj.wikis = newValue
}

function removeSampling(index) {
    instrumentStore.instrument.sample_rate.custom.splice(index, 1);
}

function addSampling() {
    // TODO: why is a basic button triggering submit? (had to add a .prevent modifier above)
    instrumentStore.instrument.sample_rate.custom.push({ wikis: new Array(), chipWikis: new Array(), rate: instrumentStore.instrument.sample_rate.default });
}
</script>

<template>
    <h2>Sampling</h2>

    <!-- SPECIFICATIONS: Sample Unit -->
    <cdx-field>
        <cdx-select
            v-model:selected="instrumentStore.instrument.sample_unit"
            :menu-items="samplingUnitMenuItems"
            default-label="Select the sample unit"
            data-id="sample-unit"
            :disabled="instrumentStore.isActivatedABTest"
            v-tooltip="instrumentStore.activatedABTooltip"
        />
        <template #label>
            Sample unit
        </template>
        <template #description>
            Choose the segment that will define your sample.
            <a class="cdx-docs-link" target="_new" href="https://wikitech.wikimedia.org/wiki/Metrics_Platform/Analytics_sampling">Learn more</a>
        </template>
    </cdx-field>

    <cdx-field>
    <template #label>
        Project and sample size
    </template>
    <template #description>
        Define the rate of the selected sampling unit that should be tracked in each relevant project.
    </template>
    <div class="field-group">
        <div class="column-2">
            <div class="column">
                <cdx-field>
                    <template #label>Wiki project</template>
                    <template #help-text>Sample size assigned by default to all projects</template>
                    <cdx-text-input
                        placeholder="All projects"
                        :readonly="true"
                    />
                </cdx-field>
            </div>
            <div class="column right">
                <cdx-field>
                    <template #label>Sample size</template>
                    <cdx-text-input
                        class="number" min="0" max="1" step="0.01"
                        v-model="instrumentStore.instrument.sample_rate.default"
                        inputType="number"
                        :readonly="instrumentStore.isActivatedABTest"
                        v-tooltip="instrumentStore.activatedABTooltip"
                    />
                </cdx-field>
            </div>
            <div class="clearfix"></div>
        </div>
        <div class="column-4" v-for="rateObj, index in instrumentStore.instrument.sample_rate.custom">
            <div class="column">
                <cdx-multiselect-lookup
                    v-model:input-chips="rateObj.chipWikis"
                    v-model:selected="rateObj.wikis"
                    :menu-items="locationsMenuItems"
                    @input="onLocationsInput"
                    @update:selected="(newValue) => wikisChanged(rateObj, newValue)"
                    :readonly="instrumentStore.isActivatedABTest"
                    placeholder="Type and select a project"
                    v-tooltip="instrumentStore.activatedABTooltip"
                />
            </div>
            <div class="column right smaller-column">
                <cdx-text-input
                    class="number" min="0" max="1" step="0.01"
                    v-model="rateObj.rate"
                    inputType="number"
                    :readonly="instrumentStore.isActivatedABTest"
                    v-tooltip="instrumentStore.activatedABTooltip"
                />
                <cdx-button
                    action="default"
                    weight="quiet"
                    aria-label="Remove this sample size"
                    :disabled="instrumentStore.isActivatedABTest"
                    @click.prevent="removeSampling(index, $event)"
                    v-tooltip="instrumentStore.activatedABTooltip"
                >
                    <cdx-icon :icon="cdxIconTrash" />
                </cdx-button>
            </div>
            <div class="clearfix"></div>
        </div>
        <div class="button-container">
            <cdx-button
                aria-label="Add a project"
                :disabled="instrumentStore.isActivatedABTest"
                @click.prevent="addSampling"
                v-tooltip="instrumentStore.activatedABTooltip"
            >
                <cdx-icon :icon="cdxIconAdd" /> Add a project
            </cdx-button>
        </div>
    </div>
    </cdx-field>
</template>

<style scoped>
.cdx-text-input.number {
    display: inline-block;
    width: 90px;
    min-width: 90px;
    padding-right: 20px;
}
.column-2 {
    padding: 0;
}
.right-align {
    text-align: right;
    line-height: 31px;
    vertical-align: middle;
}
.cdx-button {
    vertical-align: top;
}
.field-group .cdx-field {
    width: 100%;
}
.button-container {
    padding-top: 20px;
}
.cdx-select-vue {
    display: block;
}

/**
 * TODO: Make this responsive by using flexbox.
 */
.column {
    width: 75%;
}
.column.right {
    width: 25%
}
</style>
